//------------------------------------------------------------------------------
//
//  npdata.h
//  npe
//
//  Created by Shane Saxon on 2/19/10.
//  Copyright Saxon Digital 2010. All rights reserved.
//
//------------------------------------------------------------------------------

#ifndef npdata_H_
#define npdata_H_

// #define _LINUX_
#define _MSW_
// #define _OSX_

#define kKeyMapSize 256
#define kKeyEventTypeSize 4

#define	kPlotMaximum 4096
#define kGridCount 10
#define kDefaultScale = 1.0

#include <freeglut.h>



enum {
	kRawSample = 0,
	kAverage,
	kRootMeanSquare,
	kSmoothed
};

enum {
	kLeftJustify = 0,
	kRightJustify,
	kCenterJustify
};

enum {
	kSmallFont = 0,
	kMediumFont,
	kLargeFont
};

enum
{
	kChannelNull = 0,
	kChannelCycleCount,
	kChannelOscilloscope
};

struct Key {
	int		modShift;
	int		modCtrl;
	int		modAlt;
	int		modCommand;
	int		map[kKeyEventTypeSize][kKeyMapSize];
};
typedef struct Key Key;
typedef struct Key * pKey;

struct DataMap {
	int		size;
};
typedef struct DataMap DataMap;
typedef struct DataMap * pDataMap;

struct IO {
	int		size;
	Key		key;
	void*	plot[kPlotMaximum];
};
typedef struct IO IO;
typedef struct IO * pIO;

struct Ctrl {
	int		size;
};
typedef struct Ctrl Ctrl;
typedef struct Ctrl * pCtrl;

struct Data {
	DataMap map;
	IO		io;
	Ctrl	ctrl;
};
typedef struct Data Data;
typedef struct Data * pData;


typedef struct {
   GLdouble x,y,z;
} recVec;

typedef struct {
	GLfloat x,y,z;
} GLfloatXYZ;

typedef struct {
	GLfloat angle,x,y,z;
} GLfloatAngleXYZ;

typedef struct {
	GLfloat r,g,b,a;
} GLfloatRGBA;

typedef struct {
	int x,y,z;
} IntXYZ;

typedef struct {
	GLubyte r,g,b,a;
} GLubyteRGBA;

typedef struct {
	GLboolean x,y,z;
} BoolXYZ;

typedef struct {
	GLboolean angle,x,y,z;
} BoolAXYZ;


//--- Functions ----------------------------------------------------------------

void npInitData (int argc, char* argv[], void* data);		// inits default
void npCloseData();

void* npDataGetDataRef();

void npDataUpdate (void* dataRef);

#endif

